package org.apache.hadoop.mapred;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import java.io.*;
import java.util.*;
import org.apache.hadoop.mapred.*;
import org.apache.hadoop.util.*;
import javax.servlet.jsp.*;
import java.text.SimpleDateFormat;
import org.apache.hadoop.mapred.*;
import org.apache.hadoop.mapred.JobHistory.*;

public final class jobhistory_jsp extends org.apache.jasper.runtime.HttpJspBase
    implements org.apache.jasper.runtime.JspSourceDependent {

	
	private static SimpleDateFormat dateFormat = new SimpleDateFormat("d/MM HH:mm:ss") ;


	private void printJobs(String trackerid, Map<String, JobInfo> jobs, String status, JspWriter out) throws IOException{
	  if( jobs.size() == 0 ) {
	    out.print("<h3>No Jobs available</h3>"); 
	    return ; 
	  }
      out.print("<table border=2 cellpadding=\"5\" cellspacing=\"2\">");
      out.print("<tr>");
   	  out.print("<td align=\"center\">Job Id</td><td>Name</td><td>User</td><td>Submit Time</td>" + 
   	      "<td>Finish Time</td><td>Total Maps</td><td>Total Reduces</td>" +
   		  "<td>Finished Maps</td><td>Finished Reduces</td>") ; 
   	  out.print("</tr>"); 
   	      
	  for( JobInfo job : jobs.values() ) {
		if( null != status && status.equals(job.get(Keys.JOB_STATUS)) ) {
		  printJob(trackerid, job, out); 
		}else if( status == null && job.get(Keys.JOB_STATUS).length() == 0 ) {
		  printJob(trackerid, job, out); 
		}
	  }
	  out.print("</table>");
	}

	private void printJob(String trackerid, JobInfo job, JspWriter out)throws IOException{
	    out.print("<tr>"); 
	    out.print("<td>" + "<a href=\"jobdetailshistory.jsp?jobid="+ job.get(Keys.JOBID) + 
	        "&jobTrackerId=" +trackerid  + "\">" + job.get(Keys.JOBID) + "</a></td>"); 
	    out.print("<td>" + job.get(Keys.JOBNAME) + "</td>"); 
	    out.print("<td>" + job.get(Keys.USER) + "</td>"); 
	    out.print("<td>" + StringUtils.getFormattedTimeWithDiff(dateFormat, job.getLong(Keys.SUBMIT_TIME),0) + "</td>"); 
	    out.print("<td>" + StringUtils.getFormattedTimeWithDiff(dateFormat, job.getLong(Keys.FINISH_TIME) , job.getLong(Keys.SUBMIT_TIME) ) + "</td>");
	    out.print("<td>" + job.get(Keys.TOTAL_MAPS) + "</td>"); 
	    out.print("<td>" + job.get(Keys.TOTAL_REDUCES) + "</td>"); 
	    out.print("<td>" + job.get(Keys.FINISHED_MAPS) + "</td>"); 
	    out.print("<td>" + job.get(Keys.FINISHED_REDUCES) + "</td>"); 
	    out.print("</tr>");
	}
 
  private static java.util.Vector _jspx_dependants;

  public java.util.List getDependants() {
    return _jspx_dependants;
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    JspFactory _jspxFactory = null;
    PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;
    PageContext _jspx_page_context = null;


    try {
      _jspxFactory = JspFactory.getDefaultFactory();
      response.setContentType("text/html; charset=UTF-8");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      _jspx_page_context = pageContext;
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;

      out.write('\n');
      org.apache.jasper.runtime.JspRuntimeLibrary.include(request, response, "loadhistory.jsp" + (("loadhistory.jsp").indexOf('?')>0? '&': '?') + org.apache.jasper.runtime.JspRuntimeLibrary.URLEncode("historyFile", request.getCharacterEncoding())+ "=" + org.apache.jasper.runtime.JspRuntimeLibrary.URLEncode(String.valueOf(request.getParameter("historyFile") ), request.getCharacterEncoding()) + "&" + org.apache.jasper.runtime.JspRuntimeLibrary.URLEncode("reload", request.getCharacterEncoding())+ "=" + org.apache.jasper.runtime.JspRuntimeLibrary.URLEncode(String.valueOf(request.getParameter("reload") ), request.getCharacterEncoding()), out, false);
      out.write('\n');
      out.write("\n\n<html><body>\n");

		DefaultJobHistoryParser.MasterIndex jobTrackerToJobs = 
		  (DefaultJobHistoryParser.MasterIndex)request.getSession().
		  getAttribute("jobHistory"); 
		
		if( null == jobTrackerToJobs ){
		  out.println("NULL !!!"); 
		  return ; 
		}

    for (Map.Entry<String, Map<String, JobInfo>> entry : 
            jobTrackerToJobs.entrySet()) {
      String trackerStartTime = entry.getKey();
      Map<String, JobInfo> jobs = entry.getValue();

      out.write("\n<h2>JobTracker started at: ");
      out.print(new Date(Long.parseLong(trackerStartTime)) );
      out.write("</h2>\n<hr/>\n<h3>Completed Jobs </h3>\n<center>\n");
	
		printJobs(trackerStartTime, jobs, Values.SUCCESS.name(), out) ; 

      out.write("\n</center> \n<h3>Failed Jobs </h3>\n<center>\n");
	
		printJobs(trackerStartTime, jobs, Values.FAILED.name() , out) ; 

      out.write("\n</center>\n<h3>Incomplete Jobs </h3>\n<center>\n");
	
		printJobs(trackerStartTime, jobs, null , out) ; 

      out.write("\n</center>\n<hr/><br/>\n");

		} // end while trackers 

      out.write('\n');
      out.write(' ');
      out.write('\n');
      out.write("  \n</body></html>\n");
    } catch (Throwable t) {
      if (!(t instanceof SkipPageException)){
        out = _jspx_out;
        if (out != null && out.getBufferSize() != 0)
          out.clearBuffer();
        if (_jspx_page_context != null) _jspx_page_context.handlePageException(t);
      }
    } finally {
      if (_jspxFactory != null) _jspxFactory.releasePageContext(_jspx_page_context);
    }
  }
}
